
#ifndef _CGDK_H_
  #define _CGDK_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #include <stdlib.h>

  extern void CGDK_init (void);
  extern void CGDK_initDebug (void);
  extern void CGDK_done (void);

  extern int _argc;
  extern char **_argv;
//  extern long CGDK_fp;

  extern char exitStr [];

  #define hi(a) (unsigned short) (((unsigned long)a) >> 16)
  #define lo(a) (unsigned short) (((unsigned long)a) & 0xFFFF)
  #define his(a) (unsigned short) (((unsigned short)a) >> 8)
  #define los(a) (unsigned short) (((unsigned short)a) & 0xFF)

  extern const char CGDK_copyright [];
  extern const char CGDK_version [];
  extern const char CGDK_date [];
  extern const char CGDK_time [];

  extern void writeln (void);
  extern int sign (int x);
  extern int resetBit (int number, int Bit);
  extern int setBit (int number, int Bit);
  extern int _div (int numer, int demon);
  extern void CGDK_exit (const char *errorStr, int exitCode); // =exitStr, =0
  extern void CGDK_abort (const char *errorStr); // =exitStr
  extern void CGDK_exitTrial (void);
  extern char *CGDK_getProgramPath (char *fileName); // = =NULL

  #define _max(a,b)    (((a) > (b)) ? (a) : (b))
  #define _min(a,b)    (((a) < (b)) ? (a) : (b))

  extern int CGDK_debug;

  #define MAXLONG 0x7FFFFFFF
  #define MAXSHORT 0x7FFF

  typedef void (* _atexit_t)(void);
  extern int _atexit (_atexit_t func);
  extern void _cexit (void);

  extern unsigned long _mallocated;
  extern unsigned long _mtotal;
  #define _mfree ((_mtotal<_mallocated) ? 0 : (_mtotal - _mallocated))

  extern int _allocCount;
  extern int _freeCount;

  extern void _minit (void);
  extern void _mdone (void);
  extern void *_alloc (int size);
  extern void *_malloc (int size, char *errorStr);
  extern void *_calloc (int n, int size, char *errorStr);
  extern void *_realloc (void *mem, int newsize, char *errorStr);
  extern void _free (void *mem);
  extern void _mexit (const char *exitStr, int requestedMemorySize);

  extern int CGDK_quite;

  #ifdef __cplusplus
  }
  #endif

#endif
