
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <stdio.h>
#include <sys\stat.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#include "cgdk.h"
#include "wait.h"
#include "pal.h"
#include "pcx.h"
#include "car.h"
#include "file.h"
#include "svga.h"
#include "spr.h"
#include "timer.h"
#include "keyb.h"
#include "tm.h"
#include "mouse.h"
#include "clip.h"

#define BORDER_COLOR_DEFAULT    (255)

TCSF *mouseCursor;
unsigned int BorderColor;
unsigned int ZeroColor;


#define USAGE_STRING \
        "Syntax is: CSFCLIP <filename.pcx> [border_color] [zero_color]\n"


TCLIP_listNode * LoadOldRects(char *ImageFileName)
{
  char SaveFileName [80];
  char *ptr;
  FILE * SaveFile;
  TCLIP_listNode * List;
  TCLIP_listNode * Node;
  int Result;
  int Top;
  int Left;
  int Bottom;
  int Right;
  char Name [80];

  strcpy (SaveFileName, ImageFileName);
  ptr = strchr (SaveFileName, '.');
  if (ptr)
  {
    *ptr = 0;
  }
  strcat (SaveFileName, ".ccs");
  SaveFile = fopen(SaveFileName, "rt");
  if (SaveFile == NULL) {
      return NULL;
  }
  // detect zero size
  fseek (SaveFile, 0, SEEK_END);
  if (ftell (SaveFile) == 0)
  {
    return NULL;
  }
  fseek (SaveFile, 0, SEEK_SET);


  if (SaveFile == NULL) {
      return NULL;
  }

  List = NULL;
  while (!feof(SaveFile)) {
              Result = fscanf(SaveFile,"%s %d %d %d %d\n", Name, &Left, &Top,
                      &Right, &Bottom);
      if (Result != 5 || Left > Right || Top > Bottom)
      {
        sprintf (exitStr, "ERROR: Savefile %s corrupted.\n", SaveFileName);
        CGDK_exit (exitStr, EXIT_FAILURE);
      }

      Node = (TCLIP_listNode *) _alloc(sizeof(TCLIP_listNode));
      Node->Rect.Top            = Top;
      Node->Rect.Left           = Left;
      Node->Rect.Bottom = Bottom;
      Node->Rect.Right  = Right;
      Node->Next                        = List;
      Node->Flag                        = 0;
      Node->Name                        = (char *) _alloc(strlen(Name) + 1);
      Node->Name[0]             = '\0';
      strcat(Node->Name, Name);
      List                              = Node;
  }

  fclose(SaveFile);
      return List;
}



int SaveOldSprites (TCLIP_listNode *SpriteRects,TCLIP_listNode *OldSpriteRects,
                     void * Image, int sizeX, TRGBColor *PAL)
{
  TCLIP_listNode * NewRect;
  TCLIP_listNode * OldRect;
  void * SpriteBitmap;
  char FileName [80];
  int NumOld;
  int SaveResult;
  TCSF *spr;
  int Height,Width;

  NumOld = 0;

  NewRect = SpriteRects;
  while (NewRect != NULL) {
      OldRect = OldSpriteRects;
      while (OldRect != NULL) {
              if (NewRect->Rect.Top == OldRect->Rect.Top &&
              NewRect->Rect.Left == OldRect->Rect.Left) {
              break;
          }
              OldRect = OldRect->Next;
      }
              if (OldRect != NULL) {
              /* we found a match */
          NumOld++;
          printf("Found sprite: %s at (%d,%d) (%d,%d).\n", OldRect->Name,
                              NewRect->Rect.Left, NewRect->Rect.Top,
                              NewRect->Rect.Right, NewRect->Rect.Bottom);

          /* print warning if things are a little amiss */
          if (NewRect->Rect.Top != OldRect->Rect.Top ||
              NewRect->Rect.Bottom != OldRect->Rect.Bottom) {
              printf("WARNING: New and old bitmaps differ in size.\n");
          }

          /* mark both as being dealt with */
          NewRect->Flag = 1;
          OldRect->Flag = 1;

          /* extract the bitmap from the image bitmap */
          SpriteBitmap = CLIP_extractSprite(Image, sizeX, NewRect->Rect.Left,
                              NewRect->Rect.Top, NewRect->Rect.Right,
                              NewRect->Rect.Bottom);

          Width = NewRect->Rect.Right - NewRect->Rect.Left - 1;
          Height = NewRect->Rect.Bottom - NewRect->Rect.Top - 1;
          /* save the extracted bitmap */
          strcpy (FileName, OldRect->Name);
          strcat (FileName,".csf");
//          if (!F_exist (FileName))
          {
            if ((spr = CSF_create (SpriteBitmap, Width, Height,PAL, 1, NULL)) != NULL)
            {
              if (CSF_save (spr, FileName) == 0)
              {
                printf ("\"%s\" succesfully saved.\n\n", FileName);
              }
              else
              {
                printf ("Error saving \"%s\".\n\n", FileName);
              }
              CSF_delete (spr);
            }
            else
            {
              printf ("Error creating sprite\"%S\".\n\n", FileName);
            }
          }

          /* move name over to new sprite and off old sprite */
          NewRect->Name = OldRect->Name;
          OldRect->Name = NULL;

          /* _free up the temp bitmap */
          _free(SpriteBitmap);
      }
      NewRect = NewRect->Next;
  }
  return NumOld;
}

void DrawRect (short startX, short startY, short lenX, short lenY, long color)
{
  int i,j;

  for (i = 0; i <= lenX+1; i++)
  {
    SVGA_putPixel (startX+i      , startY,        color);
  }
  for (j = 0; j <= lenY+1; j++)
  {
    SVGA_putPixel (startX        , startY+j,      color);
    SVGA_putPixel (startX+lenX+1 , startY+j,      color);
  }
  for (i = 0; i <= lenX+1; i++)
  {
    SVGA_putPixel (startX+i      , startY+lenY+1, color);
  }
}

void DrawSpriteRect (TCLIP_listNode * NewSprite, long color)
{
  int Width = NewSprite->Rect.Right - NewSprite->Rect.Left - 1;
  int Height = NewSprite->Rect.Bottom - NewSprite->Rect.Top - 1;

  DrawRect (NewSprite->Rect.Left, 16+NewSprite->Rect.Top,
            Width, Height, color);
}

void DrawSpriteRectFlush (TCLIP_listNode * NewSprite, long color)
{
//  SVGA_flush ();
  MOUSE_hideCursor ();
  SVGA_flush ();
  DrawSpriteRect (NewSprite, color);
  MOUSE_showCursor ();
  SVGA_flush ();
}

  #define C_INPUT 255
  #define C_OLD 252
  #define C_SAVED 254
  #define C_SELECT 253
  #define C_BACK 251
//  #define C_ERROR 249
  #define C_NEW 250


void SaveNewSprites (TCLIP_listNode *SpriteRects,
                     void *ImageBitmap, int sizeX, int sizeY, TRGBColor *pal)
{
  TRGBColor PAL [256];
  TCLIP_listNode *NewSprite, *OldSprite, *newone;
  char InLine[255];
  char fileName [80];
  void *NewBitmap;
  int BaseColor;
  TCSF *spr;
  short videoMode;
  char *inputDesk;
  int inputDeskSize;
  int numOld,numNew;
  char repeat;
  char quit;
  char save;
  char *ptr;
  char c;
  char str [1024]; // input buffer

  char lastName [80];
  int lastCount = -1;

  int Width;
  int Height;

//  TM_init ();
  videoMode = SVGA_recommendVideoMode (sizeX, sizeY+16+32, 1, VMODE_ANY);
  #ifdef __TURBOC__
    videoMode = XVGA_320x200x256+NO_SCROLL;
  #endif
  SVGA_setVideoMode (videoMode);
  PAL_clear (0, 256);
  SVGA_clear (C_BACK);
//  MOUSE_setSensitivity (1,1);
  MOUSE_setWindow (0, 16, sizeX, 16+sizeY);
  MOUSE_setPosition (0,16);
  MOUSE_setCursor (mouseCursor, 0);
  // set the frames colors (and the color of the 8x16 font as well)

  memcpy (PAL, pal, 256*sizeof (TRGBColor));
  PAL [C_INPUT].r = 200;
  PAL [C_INPUT].g = 200;
  PAL [C_INPUT].b = 200;
  PAL [C_SAVED].r = 0;
  PAL [C_SAVED].g = 255;
  PAL [C_SAVED].b = 0;
  PAL [C_SELECT].r = 255;
  PAL [C_SELECT].g = 0;
  PAL [C_SELECT].b = 0;
  PAL [C_OLD].r = 0;
  PAL [C_OLD].g = 0;
  PAL [C_OLD].b = 255;
//  PAL [C_ERROR].r = 255;
//  PAL [C_ERROR].g = 0;
//  PAL [C_ERROR].b = 255;
  PAL [C_NEW].r = 0;
  PAL [C_NEW].g = 255;
  PAL [C_NEW].b = 255;
  PAL [C_BACK].r = 64;
  PAL [C_BACK].g = 64;
  PAL [C_BACK].b = 64;

  CSF_updateColors (mouseCursor, PAL, 1, 255);
  PAL_set (PAL, 0, 256);

  NewSprite = SpriteRects;

  SVGA_flush ();
  SVGA_putSpr (ImageBitmap, 0, 16, sizeX, sizeY, sizeX);
  MOUSE_hideCursor ();
  SVGA_flush ();

  inputDeskSize = 2*16*SVGA_maxX;
  inputDesk = (char *) _alloc (inputDeskSize);
  memset (inputDesk, C_BACK, inputDeskSize);

  OldSprite = NewSprite;

  numOld = 0;
  numNew = 0;
  while (OldSprite != NULL)
  {
    if (OldSprite->Flag)
    {
      DrawSpriteRect (OldSprite, C_OLD);
      numOld++;
    }
    else
    {
      DrawSpriteRect (OldSprite, C_NEW);
      numNew++;
    }
    OldSprite = OldSprite->Next;
  }

  sprintf (str, "Found %i old and %i new sprites", numOld, numNew);
  SVGA_putStr (0,0,str,C_INPUT);
  MOUSE_showCursor ();
  SVGA_flush ();

  quit = 0;

  save = 1;
  while ((numNew) && (!quit))
  {
    if (NewSprite->Flag == 0)
    {
      // handle a new sprite
      if (OldSprite != NewSprite)
      {
        NewBitmap = CLIP_extractSprite(ImageBitmap, sizeX,
                                  NewSprite->Rect.Left,
                                  NewSprite->Rect.Top, NewSprite->Rect.Right,
                                  NewSprite->Rect.Bottom);

        sprintf(str,"New sprite (%i) at (%d,%d) (%d,%d).\n",NewSprite->count,
                    NewSprite->Rect.Left, NewSprite->Rect.Top,
                    NewSprite->Rect.Right, NewSprite->Rect.Bottom);

        SVGA_putWin (inputDesk, 0, SVGA_maxY - 32, SVGA_maxX, 32, SVGA_maxX);
        SVGA_flush ();
        SVGA_putStr (0, SVGA_maxY - 32, str, C_INPUT);

        Width = NewSprite->Rect.Right - NewSprite->Rect.Left - 1;
        Height = NewSprite->Rect.Bottom - NewSprite->Rect.Top - 1;

        DrawSpriteRectFlush (NewSprite, C_SELECT);
        OldSprite = NewSprite;
      }

      do
      {
        SVGA_update (1);

        repeat = 0;

        if (lastCount != -1)
        {
          do
          {
            sprintf (fileName, "%s%04i.csf", lastName, lastCount);
            lastCount++;
          }
          while (F_exist (fileName));
          *(strchr (fileName,'.')) = 0;
        }
        else
        {
          MOUSE_updateCursor ();
          if (MOUSE_info.buttons.left)
          {
            while (MOUSE_info.buttons.left)
              ;

            newone = CLIP_findSpriteAt (SpriteRects, MOUSE_info.x, MOUSE_info.y-16);
            if ((newone) && (newone != NewSprite))
            {
              DrawSpriteRectFlush (NewSprite, C_NEW);
              NewSprite = newone;
              save = 0;
              continue;
            }
          }
          c = KEYB_get ();
          if (MOUSE_info.buttons.right)
          {
            while (MOUSE_info.buttons.right)
              ;
            c = KEY_ENTER;
          }
          switch (c)
          {
            case KEY_ENTER:
            {
              SVGA_putWin (inputDesk,0, SVGA_maxY-16, SVGA_maxX, 16, SVGA_maxX);
              SVGA_flush ();
              SVGA_getStr (0, SVGA_maxY-16, fileName, C_INPUT, C_BACK);
              if (strchr (fileName, '*'))
              {
                strcpy (lastName, fileName);
                ptr = strchr (lastName, '*');
                *ptr = 0;
                if (strlen (lastName) > 4)
                {
                  lastName [4] = 0;
                }
                lastCount = 0;
              }
              if (strlen (fileName))
              {
                save = 1;
              }
              else
              {
                repeat = 1;
                continue;
              }
              break;
            }
            case KEY_PLUS:
            {
              newone = NewSprite;
              do
              {
                newone = newone->Next;
              }
              while ((newone != NULL) && (newone->Flag != 0));
              if (newone)
              {
                DrawSpriteRectFlush (NewSprite, C_NEW);
                NewSprite = newone;
              }
              save = 0;
              continue;
            }
            case KEY_MINUS:
            {
              newone = NewSprite;
              do
              {
                newone = newone->Prev;
              }
              while ((newone != NULL) && (newone->Flag != 0));
              if (newone)
              {
                DrawSpriteRectFlush (NewSprite, C_NEW);
                NewSprite = newone;
              }
              save = 0;
              continue;
            }
            case KEY_ESC:
            {
              quit = 1;
              save = 0;
              break;
            }
            default:
            {
              repeat = 1;
              continue;
            }
          }
        }


        if (save)
        {
          if (strlen (fileName))
          {
            strcat (fileName,".csf");
            if ((spr = CSF_create (NewBitmap, Width, Height,pal, 1, NULL)) != NULL)
            {
              /*
              printf ("\"%s\" contains %i colors.\n", FileName, spr->maxColor);

              do
              {
                printf ("Enter base color (1 - %i): ", 256-spr->maxColor);
                BaseColor = 1;
                fgets (InLine, 40, stdin);
                sscanf (InLine, "%i", &BaseColor);
              }
              while (CSF_changeBaseColor (spr, BaseColor) != 0);
              */

              if (CSF_save (spr, fileName) == 0)
              {
                SVGA_putWin (inputDesk, 0, 0, SVGA_maxX, 16,SVGA_maxX);
                SVGA_flush ();
                numNew--;
                sprintf (str, "\"%s\" succesfully saved; %i new sprites left.\n\n", fileName, numNew);
                SVGA_putStr (0, 0, str, C_INPUT);
                // save name away for later
                *(strchr (fileName,'.')) = 0;
                NewSprite->Name = (char *) _alloc (80);
                strcpy(NewSprite->Name, fileName);
                NewSprite->Flag = 1;

                /* save name away for later */
                strcpy(NewSprite->Name, fileName);
                NewSprite->Flag = 1;
                DrawSpriteRectFlush (NewSprite, C_SAVED);
//                SVGA_flush ();
              }
              else
              {
                SVGA_putWin (inputDesk, 0, 0, SVGA_maxX, 16, SVGA_maxX);
                SVGA_flush ();
                sprintf (str, "Error saving \"%s\".\n\n", fileName);
                SVGA_putStr (0,0, str, C_INPUT);
//                SVGA_flush ();
  //            DrawSpriteRectFlush (NewSprite, C_ERROR);
                repeat = 1;
              }
              CSF_delete (spr);
            }
            else
            {
              SVGA_putWin (inputDesk, 0, 0, SVGA_maxX, 16, SVGA_maxX);
              SVGA_flush ();
              sprintf (str, "Error creating sprite\"%S\".\n\n", fileName);
              SVGA_putStr (0,0, str, C_INPUT);
              SVGA_flush ();
//            DrawSpriteRectFlush (NewSprite, C_ERROR);
            }
          }
//        else
//        {
//            DrawSpriteRectFlush (NewSprite, C_ERROR);
//          }
        }
      }
      while (repeat && (!quit));

      _free(NewBitmap);
    }
    if (save)
    {
      NewSprite = NewSprite->Next;
      if (NewSprite == NULL)
      {
        NewSprite = SpriteRects;
      }
    }
  }

  MOUSE_done ();
  SVGA_done ();
}


void WriteSaveFile(TCLIP_listNode * Rects, char * ImageFile)
{
  char SaveFileName [80];
  FILE * SaveFile;
  TCLIP_listNode * List;
  char *ptr;

  strcpy (SaveFileName, ImageFile);
  ptr = strchr (SaveFileName, '.');
  if (ptr)
  {
    *ptr = 0;
  }
  strcat (SaveFileName, ".ccs");

  /* open SaveFilename */
  SaveFile = fopen(SaveFileName, "wt");

  /* if error, exit */
  if (SaveFile == NULL) {
      return;
  }

  /* write out rectangle data */
  List = Rects;
  while (List != NULL) {
      if (List->Flag) {
              fprintf(SaveFile, "%s %d %d %d %d\n", List->Name,
                              List->Rect.Left, List->Rect.Top,
                              List->Rect.Right, List->Rect.Bottom);
      }
      List = List->Next;
  }

  /* close file and return to caller */
  fclose(SaveFile);
}



int main(void)
{
  void *ImageBitmap;
  char *ImageFile;
  int ImageSizeX;
  int ImageSizeY;
  int  ImageBytesPerPixel;
  int videoMode;
  unsigned i;

  TCAR *carHandle;
  char defColor = 1;
  TCLIP_listNode * SpriteRects;
  TCLIP_listNode * OldSpriteRects;
  TRGBColor Palette [256];
  TRGBColor color;
  char *mouseCursorName;

  printf("\n"
         "CSFCLIP - extractor of single Cybertek Sprite/Font from PCX images\n"
         "\n%s\n",CGDK_copyright);

  CGDK_init ();
  TIMER_init (TIMER_OLDFREQ_DEF);

  // validate number of parameters
  if (_argc < 2 || _argc > 4)
  {
    printf("ERROR: Incorrect number of parameters.\n");
    CGDK_exit (USAGE_STRING, EXIT_FAILURE);
  }

  ImageFile = _argv [1];

  BorderColor = BORDER_COLOR_DEFAULT;
  ZeroColor = 0;

  if (_argc >= 3)
  {
    defColor = 0;
    sscanf(_argv[2], "%i", &BorderColor);
    if ((BorderColor > 255) || (BorderColor < 1))
    {
      printf("ERROR: Border color must be a numeric value from 1 to 255.\n");
      CGDK_exit (USAGE_STRING, EXIT_FAILURE);
    }

    if (_argc >= 4)
    {
      sscanf (_argv [3], "%i", &ZeroColor);
      if (ZeroColor > 255)
      {
        printf("ERROR: Zero color must be a numeric value from 0 to 255.\n");
        CGDK_exit (USAGE_STRING, EXIT_FAILURE);
      }
    }
  }
  if (ZeroColor == BorderColor)
  {
    CGDK_exit ("Zero color must be not equal to border color.\n", EXIT_FAILURE);
  }

  carHandle = CAR_open (CAR_EMULATION);

  if (PCX_getInfo (carHandle, ImageFile, &ImageSizeX, &ImageSizeY,
                   &ImageBytesPerPixel) != 0)
  {
    sprintf (exitStr, "ERROR: Invalid PCX file %s\n",ImageFile);
    CGDK_exit (exitStr, EXIT_FAILURE);
  }

  ImageBitmap = _alloc ((unsigned)ImageSizeY*ImageSizeX*ImageBytesPerPixel);
  if (ImageBitmap == NULL)
  {
    CGDK_exit ("ERROR: Not enough memory to load pcx picture.\n", EXIT_FAILURE);
  }

  // Load image file as a l_arge linear bitmap
  if (PCX_load (carHandle, ImageFile,
                ImageBitmap, ImageSizeX, ImageSizeY, Palette) != 0)
  {
    sprintf(exitStr, "ERROR: Can not load PCX file %s\n", ImageFile);
    CGDK_exit (exitStr, EXIT_FAILURE);
  }

  if (defColor)
  {
    i = 0;
    ZeroColor = ((unsigned char *)ImageBitmap) [0];
    while (((char *)ImageBitmap) [i] == ZeroColor)
      i++;
    BorderColor = ((unsigned char *)ImageBitmap) [i];
  }

  mouseCursorName = CGDK_getProgramPath ("mouse.csf");
  mouseCursor = CSF_new (carHandle, mouseCursorName);
  if (mouseCursor == NULL)
  {
    sprintf (exitStr, "ERROR: Can not load %s file\n",mouseCursorName);
    CGDK_exit (exitStr, EXIT_FAILURE);
  }

  if (ZeroColor)
  {
    color = Palette [ZeroColor];
    Palette [ZeroColor] = Palette [0];
    Palette [0] = color;
    // now change the default zero color to a new color

    for (i = 0; i < ImageSizeX*ImageSizeY; i++)
    {
      if (((char *)ImageBitmap) [i] == 0)
      {
        ((unsigned char *)ImageBitmap) [i] = ZeroColor;
      }
      else
      {
        if (((unsigned char *)ImageBitmap) [i] == ZeroColor)
        {
          ((unsigned char *)ImageBitmap) [i] = 0;
        }
      }
    }
  }

  SpriteRects = CLIP_findAllSprites(ImageBitmap, BorderColor,
                                    ImageSizeX, ImageSizeY,
                                    WAIT_flashPrint);
  if (SpriteRects == NULL)
  {
    CGDK_exit ("No sprites found.\n", EXIT_FAILURE);
  }

  OldSpriteRects = LoadOldRects(ImageFile);

  SaveOldSprites(SpriteRects, OldSpriteRects, ImageBitmap, ImageSizeX, Palette);

  KEYB_init ();

  SaveNewSprites(SpriteRects, ImageBitmap, ImageSizeX, ImageSizeY, Palette);

  WriteSaveFile(SpriteRects, ImageFile);

  _free(ImageBitmap);

  return 0;
}
