
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <mem.h>

#include <stdio.h>

#include "keyb.h"
#include "mouse.h"
//#include "svga.h"
#include "timer.h"
#include "dpmi.h"
#include "cgdk.h"

#include "mousemu_.cpp"
#include "pcode_.cpp"

extern void PCODE_popup (void);

//#define DEBUG

// interrupt acknowledgement stuff
#define KEYB_KEYBUF_MAX 20

#define BIOS_KEYBFLAGS 0x417
#define MAX_SCANCODES 128
#define RELEASE 0x80
#define KEYB_INT 0x09
#define KEYB_INPUT 0x60
#define KEYB_STATUS 0x64
#define KEYB_S_OUTPUT_BUFFER 2
#define KEYB_S_INPUTDATA 1

#define KEYB_ACK 0xFA
#define KEYB_NAK 0xFE

#define KEYB_MODE_BIOS 0
#define KEYB_MODE_DIRECT 1

#define DEF_CTRLBREAK_MESSAGE\
  "\n"\
  "Program has been terminated pressing Ctrl-Break.\n"

extern void far interrupt KEYB_intHandler (INTERRUPT_ARG);

char KEYB_defaultCtrlBreakMessage [] = DEF_CTRLBREAK_MESSAGE;

TKEYB_flags KEYB_flags, KEYB_updateFlags;
int KEYB_capsLock;
int KEYB_numLock;
int KEYB_scrollLock;
int KEYB_releaseShift = 0;
int KEYB_enableLEDS = 1;
int KEYB_enableBreak = 1;
int KEYB_enableReboot = 1;
char *KEYB_ctrlBreakMessage = KEYB_defaultCtrlBreakMessage;

static char KEYB_oldFlags;
static int KEYB_reboot;
static int KEYB_break;
static int KEYB_pcodePopup;
int KEYB_updateLock;
//static int KEYB_interrupt;

struct TKEYB_biosFlags
{
  unsigned int rshift : 1;
  unsigned int lshift : 1;
  unsigned int ctrl : 1;
  unsigned int alt : 1;
  unsigned int scrollLock : 1;
  unsigned int numLock : 1;
  unsigned int capsLock : 1;
  unsigned int insert : 1;
};

struct TKEYB_biosFlagsEnhanced
{
  unsigned int lctrl : 1;
  unsigned int lalt : 1;
  unsigned int sysreq : 1;
  unsigned int pause : 1;
  unsigned int scrolllock : 1;
  unsigned int numlock : 1;
  unsigned int capslock : 1;
  unsigned int insert : 1;
};

static TKEYB_biosFlags KEYB_biosFlags;
static TKEYB_biosFlagsEnhanced KEYB_biosFlagsEnhanced;


//static int (*waitHandler) (void);
static void interrupt far (*oldInt9) (INTERRUPT_ARG);
static volatile unsigned char keysTab [MAX_SCANCODES];
static volatile unsigned char KEYB_keyBuf [KEYB_KEYBUF_MAX];
static volatile int KEYB_keyBufCur;

static char asciiTab [MAX_SCANCODES] =
  {0  ,KEY_BIOS_ESC,'1','2','3','4','5','6','7','8','9','0','-','=',
  KEY_BIOS_BACKSPACE  ,KEY_BIOS_TAB  ,
   'q','w','e','r','t','y','u','i','o','p','[',']',KEY_BIOS_ENTER
   ,0  , // control
   'a','s', 'd','f','g','h','j','k','l',';','\'','`',
   0, // left shift
   '\\','z','x','c','v', 'b','n','m',',','.','/',
   0  ,// right shift
   '*'  ,// print screen
   0  ,// alt
   ' ',
   0  ,//caps lock
   0  ,0  ,0  ,0  ,0  , 0  ,0  ,0  ,0  ,0, // f1 - f10
   0  , // num lock,
   0  , // scroll lock
   '7','8','9','-','4','5','6','+','1','2','3','0','.'};

static char asciiShiftTab [MAX_SCANCODES] =
  {0  ,KEY_BIOS_ESC,'!','@','#','$','%','^','&','*','(',')','_','+',
  KEY_BIOS_BACKSPACE  ,KEY_BIOS_TAB  ,
   'Q','W','E','R','T','Y','U','I','O','P','{','}',KEY_BIOS_ENTER
   ,0  , // control
   'A','S', 'D','F','G','H','J','K','L',':','"','~',
   0, // left shift
   '\\','Z','X','C','V', 'B','N','M','<','>','?',
   0  ,// right shift
   '*'  ,// print screen
   0  ,// alt
   ' ',
   0  ,//caps lock
   0  ,0  ,0  ,0  ,0  , 0  ,0  ,0  ,0  ,0, // f1 - f10
   0  , // num lock,
   0  , // scroll lock
   '7','8','9','-','4','5','6','+','1','2','3','0','.'};

static char *descTab [MAX_SCANCODES] =
  {"None","Escape","1","2","3","4","5","6","7","8","9","0","-","=",
  "Backspace","Tab",
   "Q","W","E","R","T","Y","U","I","O","P","[","]",
   "Enter"
   ,"Left control", // control
   "A","S", "D","F","G","H","J","K","L",";","\"","`",
   "Left shift", // left shift
   "\\","Z","X","C","V", "B","N","M",",",".","/",
   "Right shift ",// right shift
   "[*]"  ,// print screen
   "Left alt"  ,// alt
   "Spacebar",
   "Caps lock"  ,//caps lock
   "F1"  ,"F2"  ,"F3"  ,"F4"  ,"F5"  , "F6"  ,"F7"  ,"F8"  ,"F9"  ,"F10",
   "Num lock"  , // num lock,
   "Scroll lock"  , // scroll lock
   "[7]","[8]","[9]","[-]","[4]","[5]","[6]","[+]","[1]","[2]","[3]","[0]","[.]",
   "Sysreq",
   NULL,
   NULL,
   "F11",
   "F12",
   // cybertek "scancodes" follows:
   "Right alt",
   "Right control",
   "Pause",
   "Insert",
   "Delete",
   "Home",
   "End",
   "Page up",
   "Page down",
   "Left arrow",
   "Right arrow",
   "Up arrow",
   "Down arrow",
   "Print screen",
   "Break"
   };

/*
  Function: KeyIntHandler
  Description:
    Replacement for the BIOS Int 9 handler.  Detects when a
      key is pressed and released.  Updates keysTab to
      reflect the state of each key.  Sets keysTab to 1 if key
      is currently being held down, 0 if released.  When a key is
      released, WasPressedTab is set to 1.  This allows a program to
      detect that a key was pressed and then released between
      checks of the Tab.  WasPressedTab is cleared by the program
      reading the state of a key, not by this routine.  keysTab
      and WasPressedTab are indexed by the KEYBoard scan code returned
      from the KEYBoard controller.
*/


/*
static int _waitHandler (void)
{
  if (waitHandler != NULL)
  {
    return waitHandler ();
  }
  return 0;
}
*/

/*
extern "C" void KEYB_setWaitHandler ( int (*handler) (void))
{
  waitHandler = handler;
}
*/

static void keyPress (char scanCode)
{
  keysTab[scanCode] |= KEY_HOLD;
  if (KEYB_keyBufCur < KEYB_KEYBUF_MAX)
  {
    KEYB_keyBuf [KEYB_keyBufCur] = scanCode;
    KEYB_keyBufCur++;
  }
}

static void keyRelease (char scanCode)
{
  keysTab[scanCode & (RELEASE-1)] &= KEY_HIT;
  #ifdef DEBUG
  KEYB_keyBuf = scanCode;
  #endif
}

static unsigned char kbuf [2];
static char kpos;

/*
#define RING_POPUP KEY_A, KEY_A | RELEASE,\
                   KEY_ENTER, KEY_ENTER | RELEASE
*/

#define RING_POPUP KEY_A, KEY_A | RELEASE,\
                   KEY_B, KEY_B | RELEASE,\
                   KEY_O, KEY_O | RELEASE,\
                   KEY_U, KEY_U | RELEASE,\
                   KEY_T, KEY_T | RELEASE,\
                   KEY_SPACE, KEY_SPACE | RELEASE,\
                   KEY_C, KEY_C | RELEASE,\
                   KEY_G, KEY_G | RELEASE,\
                   KEY_D, KEY_D | RELEASE,\
                   KEY_K, KEY_K | RELEASE,\
                   KEY_SPACE, KEY_SPACE | RELEASE,\
                   KEY_B, KEY_B | RELEASE,\
                   KEY_Y, KEY_Y | RELEASE,\
                   KEY_SPACE, KEY_SPACE | RELEASE,\
                   KEY_C, KEY_C | RELEASE,\
                   KEY_Y, KEY_Y | RELEASE,\
                   KEY_B, KEY_B | RELEASE,\
                   KEY_E, KEY_E | RELEASE,\
                   KEY_R, KEY_R | RELEASE,\
                   KEY_T, KEY_T | RELEASE,\
                   KEY_E, KEY_E | RELEASE,\
                   KEY_K, KEY_K | RELEASE,\
                   KEY_ENTER, KEY_ENTER | RELEASE

//static char ringpopup [200] = {RING_POPUP};
static char ring [] = {RING_POPUP};
#define RING_LEN ((sizeof ring))
static int ringpos;



static void keyUpdate (char scanCode)
{
  if (ring [ringpos] == scanCode)
  {
    ringpos++;
    if (ringpos == RING_LEN)
    {
      KEYB_pcodePopup = 1;
      ringpos=0;
    }
  }
  else
    ringpos = 0;

  if (scanCode & RELEASE)
  {
    keyRelease (scanCode);
  }
  else
  {
    keyPress (scanCode);
  }
  kpos = 0;
}

#define MAX_WAIT 65535

static int k_waitOutputData ()
{
  unsigned short wait;

  for (wait = 0; wait < MAX_WAIT; wait++)
  {
    if (!(inp (KEYB_STATUS) & KEYB_S_OUTPUT_BUFFER))
      break;
  }

  return (wait < MAX_WAIT);
}

static int k_waitInputData ()
{
  unsigned short wait;

  for (wait = 0; wait < MAX_WAIT; wait++)
  {
    if ((inp (KEYB_STATUS) & KEYB_S_INPUTDATA))
      break;
  }

  return (wait < MAX_WAIT);
}

void KEYB_portPause (void)
{

}
/*
#else

extern void KEYB_portPause (void);
#pragma aux KEYB_portPause = \
"  mov  eax,1000"\
"waitloop:"\
"  dec  eax"\
"  je   waitloop"\
modify [eax]

#endif
*/

static void updateLEDS (TKEYB_flags flags)
{
  if (KEYB_enableLEDS)
  {
    if (k_waitOutputData ())
    {
      KEYB_portPause ();
      outp (KEYB_INPUT, 0xED);
      KEYB_portPause ();
      if (k_waitOutputData ())
      {
        KEYB_portPause ();
        if (k_waitInputData ())
        {
          KEYB_portPause ();
          if (inp (KEYB_INPUT) != KEYB_ACK)
          {
            return;
          }
        }
        KEYB_portPause ();
        outp (KEYB_INPUT, *(char *) &flags);
      }
    }
  }
}

static int popuplock;

void KEYB_update (void)
{
  if (!KEYB_updateLock)
  {
    if (*(char *)&KEYB_updateFlags != *(char *)&KEYB_flags)
    {
      updateLEDS (KEYB_flags);
      KEYB_updateFlags = KEYB_flags;
    }

    if (KEYB_enableReboot)
    {
      if (KEYB_reboot==1)
      {
        KEYB_reboot = 2;
        DPMI_reboot (REBOOT_WARM);
      }
    }

    if (KEYB_enableBreak)
    {
      if (KEYB_break==1)
      {
        KEYB_break=2;
        CGDK_exit (KEYB_ctrlBreakMessage, 0);
      }
    }

    if (KEYB_pcodePopup)
    {
      if (!popuplock)
      {
        KEYB_pcodePopup = 0;
        popuplock = 1;
        PCODE_popup ();
      }
    }
  }
}


/*
  Function: KEYB_Init
  Description:
    initializes Tabs and installs the INT 9 handler, KEYB_IntHandler().
*/

void KEYB_init (void)
{
  if (oldInt9 == NULL)
  {
//    _atexit (KEYB_done);
    /* initialize state Tabs */
    KEYB_keyBufCur = 0;

    memset ((void *)keysTab, 0, sizeof keysTab);

    *(char *) &KEYB_biosFlags = *(char *) MK_DP (0, BIOS_KEYBFLAGS);

    memset ((void *)&KEYB_flags, 0, sizeof KEYB_flags);
    KEYB_capsLock = 0;
    KEYB_numLock = 1;
    KEYB_scrollLock = 0;
    KEYB_flags.numLock = 1;
    KEYB_flags.capsLock = 0;
    KEYB_flags.scrollLock = 0;
    KEYB_flags.break_ = 0;

    /* install new handler */
    oldInt9 = _dos_getvect (KEYB_INT);
    _dos_setvect(KEYB_INT, KEYB_intHandler);

    updateLEDS (KEYB_flags);
  }
}

/*
  Function: KEYB_Done
  Description:
    NormalKeys() sets the INT 9 handler back to the routine
      stored in oldInt9Handler.  This routine should only be called
      after KEYB_Init has been called.
*/

void KEYB_done (void)
{
  if (oldInt9 != NULL)
  {
    *(char *) &KEYB_biosFlagsEnhanced = 0;

    KEYB_biosFlags.lshift = (!KEYB_releaseShift) && KEYB_lshift;
    KEYB_biosFlags.rshift = (!KEYB_releaseShift) && KEYB_rshift;
    KEYB_biosFlags.alt    = (!KEYB_releaseShift) && KEYB_alt;
    KEYB_biosFlags.ctrl   = (!KEYB_releaseShift) && KEYB_ctrl;
    KEYB_biosFlagsEnhanced.lalt  = (!KEYB_releaseShift) && KEYB_lalt;
    KEYB_biosFlagsEnhanced.lctrl = (!KEYB_releaseShift) && KEYB_lctrl;

    *(char *)MK_DP (0, BIOS_KEYBFLAGS) = *(char *)&KEYB_biosFlags;
    *(char *)MK_DP (0, BIOS_KEYBFLAGS+1) = *(char *)&KEYB_biosFlagsEnhanced;

    KEYB_flags.numLock = KEYB_biosFlags.numLock;
    KEYB_flags.capsLock = KEYB_biosFlags.capsLock;
    KEYB_flags.scrollLock = KEYB_biosFlags.scrollLock;
    updateLEDS (KEYB_flags);
    /* reinstall original handler */
    _dos_setvect(KEYB_INT, oldInt9);
    oldInt9 = NULL;
  }
}


/*
  Function: KEYB_KeyPressed
  Description:
    Returns 1 if the key is currently down.  The function
    continues to return 1 as long as the key is held down.
*/


int KEYB_pressed (char scanCode)
{
  if (oldInt9 != NULL)
  {
//    KEYB_update ();
    return (keysTab [scanCode] &= KEY_PRESSED);
  }
  return -1;
}

/*
  Function: KEYB_KeyHit
  Description:
    Returns 1 if the key is down or was pressed after call HIT flag is cleared
*/


int KEYB_hit (char scanCode)
{
  unsigned char ch;

  if (oldInt9 != NULL)
  {
//    KEYB_update ();
    ch = (keysTab [scanCode] & KEY_HIT);
    keysTab [scanCode] &= (KEY_PRESSED);
    return (ch);
  }
  return 0;
}

static int _mygetch ()
{
  int c;
  c = getch ();
  if (c == 0)
  {
    c = getch () << 8;
  }
  return c;
}

void KEYB_keyBufReset (void)
{
  KEYB_keyBufCur = 0;
}


int KEYB_get (void)
{
  unsigned char Ch;

  if (oldInt9 != NULL)
  {
    KEYB_update ();

    if (KEYB_keyBufCur)
    {
      KEYB_keyBufCur--;
      Ch = KEYB_keyBuf [KEYB_keyBufCur];
      return Ch;
    }
    else
      return 0;
  }
  else
  {
    if (kbhit ())
    {
      return _mygetch ();
    }
    else
    {
      return 0;
    }
  }
}

void KEYB_flush (void)
{
  KEYB_keyBufCur = 0;
}

int KEYB_wait (void)
{
  unsigned char Ch;

  while (Ch = KEYB_get (), Ch == 0)
  {
//    if (_waitHandler () != 0)
//    {
//      return KEY__ABORT;
//    }
  }
  return Ch;
}

char KEYB_ascii (char scanCode)
{
  char c;

  if ((signed)scanCode == -1)
    return -1;

  if (oldInt9 != NULL)
  {
    if (!KEYB_flags.numLock)
    {
      switch (scanCode)
      {
        case KEY__0:
        case KEY__1:
        case KEY__2:
        case KEY__3:
        case KEY__4:
        case KEY__5:
        case KEY__6:
        case KEY__7:
        case KEY__8:
        case KEY__9:
        case KEY__PERIOD:
        {
          scanCode = 0;
          break;
        }
      }
    }
    else
    {

    }
    if (KEYB_shift)
    {
      c = asciiShiftTab [scanCode];
      if (KEYB_flags.capsLock)
      {
        c = tolower (c);
      }
    }
    else
    {
      c = asciiTab [scanCode];
      if (KEYB_flags.capsLock)
      {
        c = toupper (c);
      }
    }

    return c;
  }
  else
  {
    return scanCode;
  }
}

char KEYB_key (char scanCode)
{
  if (oldInt9 != NULL)
  {
    if (KEYB_flags.numLock)
    {
      switch (scanCode)
      {
        case KEY__0:
        {
          scanCode = KEY_0;
          break;
        }
        case KEY__1:
        {
          scanCode = KEY_1;
          break;
        }
        case KEY__2:
        {
          scanCode = KEY_2;
          break;
        }
        case KEY__3:
        {
          scanCode = KEY_3;
          break;
        }
        case KEY__4:
        {
          scanCode = KEY_4;
          break;
        }
        case KEY__5:
        {
          scanCode = KEY_5;
          break;
        }
        case KEY__6:
        {
          scanCode = KEY_6;
          break;
        }
        case KEY__7:
        {
          scanCode = KEY_7;
          break;
        }
        case KEY__8:
        {
          scanCode = KEY_8;
          break;
        }
        case KEY__9:
        {
          scanCode = KEY_9;
          break;
        }
        case KEY__PERIOD:
        {
          scanCode = KEY_COMMA;
          break;
        }
      }
    }
    else
    {
      switch (scanCode)
      {
        case KEY__0:
        {
          scanCode = KEY_INS;
          break;
        }
        case KEY__1:
        {
          scanCode = KEY_END;
          break;
        }
        case KEY__2:
        {
          scanCode = KEY_DOWN;
          break;
        }
        case KEY__3:
        {
          scanCode = KEY_PGDN;
          break;
        }
        case KEY__4:
        {
          scanCode = KEY_LEFT;
          break;
        }
        case KEY__5:
        {
          scanCode = 0;
          break;
        }
        case KEY__6:
        {
          scanCode = KEY_RIGHT;
          break;
        }
        case KEY__7:
        {
          scanCode = KEY_HOME;
          break;
        }
        case KEY__8:
        {
          scanCode = KEY_UP;
          break;
        }
        case KEY__9:
        {
          scanCode = KEY_PGUP;
          break;
        }
        case KEY__PERIOD:
        {
          scanCode = KEY_DEL;
          break;
        }
      }
    }
  }
  return scanCode;
}


char *KEYB_desc (char scanCode)
{
  if (oldInt9 != NULL)
  {
    return descTab [scanCode & (RELEASE-1)];
  }
  else
  {
    return NULL;
  }
}


/*
void KEYB_setDirectMode (void)
{
  KEYB_init ();
}

void KEYB_setBIOSMode (void)
{
  KEYB_done ();
}
*/

#pragma off (check_stack)
#pragma saveregs
void far interrupt KEYB_intHandler(INTERRUPT_ARG)
{
  unsigned char scanCode;
  char breakIt;
  char a;

//  KEYB_interrupt = 1;

  breakIt = 0;
  // read the scan code
  scanCode = inp (KEYB_INPUT);

  switch (kpos)
  {
    case 0:
    {
      switch (scanCode)
      {
        case 0xE1:
        case 0xE0:
        {
          kbuf [kpos] = scanCode;
          kpos++;
          break;
        }
        default:
        {
          keyUpdate (scanCode);
          switch (scanCode)
          {
            case KEY_CAPSLOCK:
            {
              if (KEYB_capsLock)
              {
                if (KEYB_flags.capsLock)
                {
                  KEYB_flags.capsLock = 0;
//                  updateLEDS (KEYB_flags);
                }
              }
              else
              {
                if (!KEYB_flags.capsLock)
                {
                  KEYB_flags.capsLock = 1;
//                  updateLEDS (KEYB_flags);
                }
              }
              break;
            }
            case KEY_CAPSLOCK+RELEASE:
            {
              KEYB_capsLock = !KEYB_capsLock;
              break;
            }

            case KEY_NUMLOCK:
            {
              if (KEYB_numLock)
              {
                if (KEYB_flags.numLock)
                {
                  KEYB_flags.numLock = 0;
//                  updateLEDS (KEYB_flags);
                }
              }
              else
              {
                if (!KEYB_flags.numLock)
                {
                  KEYB_flags.numLock = 1;
//                  updateLEDS (KEYB_flags);
                }
              }
              break;
            }
            case KEY_NUMLOCK+RELEASE:
            {
              KEYB_numLock = !KEYB_numLock;
              break;
            }

            case KEY_SCROLLLOCK:
            {
              if (KEYB_scrollLock)
              {
                if (KEYB_flags.scrollLock)
                {
                  KEYB_flags.scrollLock = 0;
//                  updateLEDS (KEYB_flags);
                }
              }
              else
              {
                if (!KEYB_flags.scrollLock)
                {
                  KEYB_flags.scrollLock = 1;
//                  updateLEDS (KEYB_flags);
                }
              }
              break;
            }
            case KEY_SCROLLLOCK+RELEASE:
            {
              KEYB_scrollLock = !KEYB_scrollLock;
              break;
            }

          }
          break;
        }
      }
      break;
    }
    case 1:
    {
      switch (kbuf [0])
      {
        case 0xE0:
        {
          switch (scanCode & (RELEASE -1))
          {
            case KEY_SCROLLLOCK: // ctrl-break - only press is detected
            {
              keyUpdate (KEY_BREAK | (scanCode & RELEASE));
              if (scanCode == (KEY_SCROLLLOCK | RELEASE))
              {
                breakIt = 1;
              }
              break;
            }
            case KEY_LSHIFT:     // ignore shifted keys
            {
              kpos = 0;
              break;
            }

            case KEY__STAR:
            {
              keyUpdate (KEY_PRTSC | (scanCode & RELEASE));
              break;
            }
            case KEY_SLASH:
            {
              keyUpdate (KEY_SLASH | (scanCode & RELEASE));
              break;
            }
            case KEY_ENTER:
            {
              keyUpdate (KEY_ENTER | (scanCode & RELEASE));
              break;
            }
            case KEY_LALT:
            {
              keyUpdate (KEY_RALT | (scanCode & RELEASE));
              break;
            }
            case KEY_LCTRL:
            {
              keyUpdate (KEY_RCTRL | (scanCode & RELEASE));
              break;
            }

            case KEY__0:
            {
              keyUpdate (KEY_INS | (scanCode & RELEASE));
              break;
            }
            case KEY__PERIOD:
            {
              keyUpdate (KEY_DEL | (scanCode & RELEASE));
              break;
            }
            case KEY__7:
            {
              keyUpdate (KEY_HOME | (scanCode & RELEASE));
              break;
            }
            case KEY__1:
            {
              keyUpdate (KEY_END | (scanCode & RELEASE));
              break;
            }
            case KEY__9:
            {
              keyUpdate (KEY_PGUP | (scanCode & RELEASE));
              break;
            }
            case KEY__3:
            {
              keyUpdate (KEY_PGDN | (scanCode & RELEASE));
              break;
            }
            case KEY__4:
            {
              keyUpdate (KEY_LEFT | (scanCode & RELEASE));
              break;
            }
            case KEY__6:
            {
              keyUpdate (KEY_RIGHT | (scanCode & RELEASE));
              break;
            }
            case KEY__8:
            {
              keyUpdate (KEY_UP | (scanCode & RELEASE));
              break;
            }
            case KEY__2:
            {
              keyUpdate (KEY_DOWN | (scanCode & RELEASE));
              break;
            }
            default:
            {
              kpos = 0;
              break;
            }
          }
          break;
        }
        case 0xE1:
        {
          kbuf [kpos] = scanCode;
          kpos++;
          break;
        }
      }
      break;
    }
    case 2:
    {
      switch (kbuf [0])
      {
        case 0xE1:
        {
          switch (kbuf [1] & (RELEASE-1))
          {
            case KEY_LCTRL:
            {
              switch (scanCode & (RELEASE-1))
              {
                case KEY_NUMLOCK: // pause - only press is detected
                {
                  if (scanCode & RELEASE)
                  {
                    keyUpdate (KEY_PAUSE);
                  }
                  kpos = 0;
                  break;
                }
              }
              break;
            }
            default:
            {
              kpos = 0;
              break;
            }
          }
          break;
        }
      }
      break;
    }
  }


  MOUSEMU_update ();

  if (keysTab [KEY_DEL] && KEYB_ctrl && KEYB_alt)
  {
    KEYB_reboot = 1;
  }

  // xt compatible fix
  a = inp (KEYB_INPUT+1);
  outp (KEYB_INPUT+1, a | 0x80);
  outp (KEYB_INPUT+1, a);
  outp (PIC, END_OF_PIC);

  if (breakIt)
  {
    if (!KEYB_alt)
    {
      KEYB_break = 1;
    }
    else
    {
      DPMI_debugInt ();
    }
  }

//  if (keysTab [KEY_INS] && KEYB_ctrl && KEYB_alt)
//  {
//    KEYB_pcodePopup = 1;
//  }

//  KEYB_interrupt = 0;
}
