
#ifndef _PLASMA_H_
  #define _PLASMA_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #define PLASMA_HEADERSIZE 512
  #define PLASMA_DESCSIZE 64
  #define PLASMA_LABELSIZE 192
  #define PLASMA_ID 0x49504343
  #define PLASMA_VERSION 0x00010000
  #define PLASMA_DESC "Cybertek Plasma Image"

  #include "pal.h"

  typedef struct {
    char desc [PLASMA_DESCSIZE];
    char label [PLASMA_LABELSIZE];
    long id;
    long version;
    long bytesPerPixel;

    long videoSizeX;
    long videoSizeY;

    long poolSizeX;
    long poolSizeY;

    long moveStepsMax;
    long moveStep;

    long colBase;
    long colMax;
    long colStepsMax;
    long colStep;
    long far *videoBuf;
    long *pool;
    long *move;
    TRGBColor *col;

    char reserved [PLASMA_HEADERSIZE
		   -PLASMA_DESCSIZE
		   -PLASMA_LABELSIZE
		   -sizeof (long)
		   -sizeof (long)

		   -sizeof (long)
		   -sizeof (long)

		   -sizeof (long)
		   -sizeof (long)

		   -sizeof (long)
		   -sizeof (long)

		   -sizeof (long)
		   -sizeof (long)
		   -sizeof (long)
		   -sizeof (long)

		   -sizeof (long far *)
		   -sizeof (long *)
		   -sizeof (long *)
		   -sizeof (TRGBColor *)];

  } TPLASMA_image;

  void PLASMA_nextStep (TPLASMA_image *pi);
  void PLASMA_unload (TPLASMA_image *pi);
//  void PLASMA_init (void);
  TPLASMA_image *PLASMA_load (char *PAK_filename, char *filename);
  int PLASMA_save (TPLASMA_image *pi, const char *filename);
  void PLASMA_done ();
  void PLASMA_setVideoBuf (TPLASMA_image *pi, void far *videobuf);
  void PLASMA_step ();
//  void PLASMA_done (void);

  #ifdef __cplusplus
  }
  #endif


#endif
