
#include "plg000.h"

#define PLASMA_DEFAULT_BASECOLOR 0

#include <stdio.h>
#include <mem.h>
#include <math.h>
#include <stdlib.h>

#include "cgdk.h"
#include "plasma.h"
#include "timer.h"

#define PLASMA_IMAGE_FILENAME "plg"PLASMA_GENERATOR".cpi"

int main (void)
{
  TPLASMA_image *p;
  int phandle;
  int exitcode;
  int basecolor = PLASMA_DEFAULT_BASECOLOR;

  printf ("\n"
          "PLSAV"PLASMA_GENERATOR" - plasma generator "PLASMA_GENERATOR"\n"
          "\n%s\n",CGDK_copyright);

  CGDK_init ();
  TIMER_init (TIMER_OLDFREQ_DEF);

  if (_argc <= 2)
  {
    if (_argc == 2)
    {
      sscanf (_argv [1], "%i", &basecolor);
      printf ("Plasma base color is %i\n", basecolor);
    }
    else
    {
      basecolor = PLASMA_DEFAULT_BASECOLOR;
      printf ("Plasma base color is default (%i)\n",basecolor);
    }

    printf ("Wait ...\n");

    p = PLASMA_CALL (basecolor, NULL);

    printf ("Saving plasma image "PLASMA_IMAGE_FILENAME" ...\n");

    if (PLASMA_save (p, PLASMA_IMAGE_FILENAME) == 0)
    {
      printf ("Done.\n\n");
      exitcode = 0;
    }
    else
    {
      printf ("Error saving plasma image.\n\n");
      exitcode = 2;
    }
  }
  else
  {
    printf ("Syntax is : PLSAV"PLASMA_GENERATOR" [basecolor]\n\n");
    exitcode = 1;
  }

  return exitcode;
}
