
#include <stdlib.h>
#include <mem.h>

#include "svga.h"
#include "scroll.h"
#include "lin.h"
#include "pal.h"
#include "dith.h"
#include "vsb.h"
#include "cgdk.h"
#include "mouse.h"
#include "keyb.h"
#include "dpmi.h"

static char *UpdateLine, *UpdateLine1, *UpdateLine2;
static char *UpdateCol, *UpdateCol1, *UpdateCol2;

static char *ShadeUpdateLine, *ShadeUpdateCol;
static int Map_CurX, Map_CurY, Map_Cur;
static int Spr_CountPerLine, Spr_CountPerCol;

static int Spr_SizeX, Spr_SizeY, Spr_Size;
static int Spr_LineAdjust,Spr_ColAdjust;
static int Map_LenX, Map_LenY;
static long Map_Len;
static int Map_XShift, Map_YShift;

static short *Lev_Map;
static char *Lev_Spr;
static short *Mask_Map;
static char *Mask_Spr;

static int limLeft, limRight, limUp, limDown;
static int curLeftRight, curUpDown;


//static char *updown_buf;
static int updown_y;
static int updown_sizeY;
static int updown_curX;
static int updown_curY;

//static char *leftright_buf;
static int leftright_x;
static int leftright_sizeX;
//static int leftright_formatX;
static int leftright_curX;
static int leftright_curY;

static char *Spr_Buf;

void SCROLL_done (void)
{
  SCROLL_setLimit (SCROLL_NOLIMIT, SCROLL_NOLIMIT, SCROLL_NOLIMIT, SCROLL_NOLIMIT);

  if (UpdateLine1)
  {
    _free (UpdateLine1);
    UpdateLine1 = NULL;
  }
  if (UpdateCol1)
  {
    _free (UpdateCol1);
    UpdateCol1 = NULL;
  }
  if (UpdateLine2)
  {
    _free (UpdateLine2);
    UpdateLine2 = NULL;
  }
  if (UpdateCol2)
  {
    _free (UpdateCol2);
    UpdateCol2 = NULL;
  }
  if (ShadeUpdateLine)
  {
    _free (ShadeUpdateLine);
    ShadeUpdateLine = NULL;
  }
  if (ShadeUpdateCol)
  {
    _free (ShadeUpdateCol);
    ShadeUpdateCol = NULL;
  }
  if (Spr_Buf)
  {
    _free (Spr_Buf);
    Spr_Buf = NULL;
  }
}


void SCROLL_init (void)
{
  SCROLL_done ();
//  _atexit (SCROLL_done);
}

void SCROLL_setMap (void *LevMap, int MapLenX, int MapLenY)
{
  Lev_Map = (short *) LevMap;
  Map_LenX = MapLenX;
  Map_LenY = MapLenY;
  Map_Len = (long)MapLenX * MapLenY;
}

int SCROLL_setSpr (void *LevSpr, int SprSizeX, int SprSizeY)
{
  SCROLL_done ();

  Lev_Spr = (char *) LevSpr;
  Spr_SizeX = SprSizeX;
  Spr_SizeY = SprSizeY;
  Spr_Size = SprSizeX * SprSizeY;
  Spr_CountPerLine = _div (SVGA_maxX, SprSizeX);
  Spr_CountPerCol  = _div (SVGA_maxY, SprSizeY);

  Spr_LineAdjust = (SVGA_maxX-1) % Spr_SizeX;
  Spr_ColAdjust = (SVGA_maxY-1) % Spr_SizeY;

  Spr_Buf = (char *) _alloc (Spr_SizeX*Spr_SizeY);
  if (Spr_Buf == NULL)
    return 1;

  if (SVGA_maxXPlus)
  {
    UpdateLine1 = (char *) _calloc (SVGA_maxX, SVGA_maxYPlus, NULL);
    if (UpdateLine1 == NULL)
    {
      SCROLL_done ();
      return 2;
    }

    UpdateLine2 = (char *) _calloc (SVGA_maxX, SVGA_maxYPlus, NULL);
    if (UpdateLine2 == NULL)
    {
      SCROLL_done ();
      return 3;
    }

    UpdateLine = UpdateLine1;

  //  UpdateCol = UpdateCol1;
    ShadeUpdateLine = (char *) _calloc (SVGA_maxX,SVGA_maxYPlus, NULL);
    if (ShadeUpdateLine == NULL)
    {
      SCROLL_done ();
      return 4;
    }

  }

  if (SVGA_maxYPlus)
  {
    UpdateCol1 = (char *) _calloc (SVGA_maxY, SVGA_maxXPlus, NULL);
    if (UpdateCol1 == NULL)
    {
      SCROLL_done ();
      return 3;
    }

    UpdateCol2 = (char *) _calloc (SVGA_maxY, SVGA_maxXPlus, NULL);
    if (UpdateCol2 == NULL)
    {
      SCROLL_done ();
      return 3;
    }

    UpdateCol = UpdateCol1;

    ShadeUpdateCol = (char *) _calloc (SVGA_maxY,SVGA_maxXPlus, NULL);
    if (ShadeUpdateCol == NULL)
    {
      SCROLL_done ();
      return 5;
    }

  }

  return 0;
}

void SCROLL_setMask (void *MaskMap, void *MaskSpr)
{
  Mask_Map = (short *) MaskMap;
  Mask_Spr = (char *) MaskSpr;
}

static void *GetMaskSpr (int pos)
{
  void *Mask;

  if ((Mask_Spr) && (Mask_Map))
  {
    Mask = Mask_Spr + Mask_Map [pos]*Spr_Size;
  }
  else
    Mask = NULL;

  return Mask;
}

static void *GetLevSpr (int pos)
{
  return (Lev_Spr + Lev_Map [pos]*Spr_Size);
}

/*
void SCROLL_redraw1 (int NewMapX, int NewMapY,
                      int NewMapXShift, int NewMapYShift)
{
  int x,y;
  int xpos, ypos;
  int mappos;
  int sprCountCol;
  int sprCountLine;

  int ycount_;
  int ypos_;

  leftright_sizeX = updown_sizeY = 0;
  curLeftRight = curUpDown = 0;

  if (NewMapX != -1)
  {
    Map_CurX = NewMapX;
    Map_XShift = 0;
  }

  if (NewMapY != -1)
  {
    Map_CurY = NewMapY;
    Map_YShift = 0;
  }
  if (NewMapXShift != -1)
  {
    Map_XShift = NewMapXShift;
  }

  if (NewMapYShift != -1)
  {
    Map_YShift = NewMapYShift;
  }

  SVGA_curX = SVGA_curY = 0;
  SVGA_curXNext = SVGA_curYNext = 0;
  SVGA_curXPrev = SVGA_curYPrev = 0;
  SVGA_dx = SVGA_dy = 0;

  SVGA_wait ();
//  SVGA_scroll ();


  sprCountLine = _div (SVGA_maxX+Map_XShift, Spr_SizeX);
  sprCountCol = _div (SVGA_maxY+Map_YShift, Spr_SizeY);

  mappos = Map_CurX+(Map_CurY+sprCountCol-1)*Map_LenX+sprCountLine;
  xpos = -Map_XShift+(sprCountLine)*Spr_SizeX;
  ypos_ = -Map_YShift+(sprCountCol)*Spr_SizeY;
  ycount_ = sprCountCol*Map_LenX;

  for (x = 0; x < sprCountLine; x++)
  {
    mappos --;
    xpos -= Spr_SizeX;
    ypos = ypos_;

    for (y = 0; y < ycount_; y+=Map_LenX)
    {
      ypos -= Spr_SizeY;
      VSB_putWin ((char *) GetLevSpr (mappos-y), xpos, ypos,
               Spr_SizeX, Spr_SizeY, Spr_SizeX);
      VSB_sput ((char *) GetMaskSpr (mappos-y), xpos, ypos,
                Spr_SizeX, Spr_SizeY, Spr_SizeX);
    }
  }

  DITHER_shadeMask (VSB_buf, SVGA_virtualX, VSB_buf, VSB_sbuf, SVGA_virtualX, SVGA_maxY, SVGA_virtualX);
  SVGA_putWin (VSB_buf, 0, 0, SVGA_maxX, SVGA_maxY, SVGA_virtualX, 0);
}


void SCROLL_redraw2 (int NewMapX, int NewMapY,
                      int NewMapXShift, int NewMapYShift)
{
  int x,y;
  int xpos, ypos;
  int mappos;
  int sprCountCol;
  int sprCountLine;

  int ycount_;
  int ypos_;

  leftright_sizeX = updown_sizeY = 0;
  curLeftRight = curUpDown = 0;

  if (NewMapX != -1)
  {
    Map_CurX = NewMapX;
    Map_XShift = 0;
  }

  if (NewMapY != -1)
  {
    Map_CurY = NewMapY;
    Map_YShift = 0;
  }
  if (NewMapXShift != -1)
  {
    Map_XShift = NewMapXShift;
  }

  if (NewMapYShift != -1)
  {
    Map_YShift = NewMapYShift;
  }

  SVGA_curX = SVGA_curY = 0;
  SVGA_curXNext = SVGA_curYNext = 0;
  SVGA_curXPrev = SVGA_curYPrev = 0;
  SVGA_dx = SVGA_dy = 0;

  SVGA_wait ();
//  SVGA_scroll ();

  sprCountLine = _div (SVGA_maxX+Map_XShift, Spr_SizeX);
  sprCountCol = _div (SVGA_maxY+Map_YShift, Spr_SizeY);

  mappos = Map_CurX+(Map_CurY+sprCountCol-1)*Map_LenX+sprCountLine;
  xpos = -Map_XShift+(sprCountLine)*Spr_SizeX;
  ypos_ = -Map_YShift+(sprCountCol)*Spr_SizeY;
  ycount_ = sprCountCol*Map_LenX;

  for (x = 0; x < sprCountLine; x++)
  {
    mappos --;
    xpos -= Spr_SizeX;
    ypos = ypos_;

    for (y = 0; y < ycount_; y+=Map_LenX)
    {
      ypos -= Spr_SizeY;

      LIN_mov (VSB_buf, xpos, ypos, SVGA_virtualX, SVGA_virtualY,
                  GetLevSpr (mappos-y), Spr_SizeX, Spr_SizeY, Spr_SizeX, P_WIN);

      LIN_mov (VSB_sbuf, xpos, ypos, SVGA_virtualX, SVGA_virtualY,
                  GetMaskSpr (mappos-y), Spr_SizeX, Spr_SizeY, Spr_SizeX, P_WIN);
    }
  }

  DITHER_shadeMask (VSB_buf, SVGA_virtualX, VSB_buf, VSB_sbuf, SVGA_virtualX, SVGA_maxY, SVGA_virtualX);
  SVGA_putWin (VSB_buf, 0, 0, SVGA_maxX, SVGA_maxY, SVGA_virtualX, 0);
}
*/

void SCROLL_redraw (int NewMapX, int NewMapY,
                      int NewMapXShift, int NewMapYShift)
{
  int x,y;
  int xpos, ypos;
  int mappos;
  int sprCountCol;
  int sprCountLine;
  void *mask;

  leftright_sizeX = updown_sizeY = 0;
  curLeftRight = curUpDown = 0;

  if (NewMapX != -1)
  {
    Map_CurX = NewMapX;
    Map_XShift = 0;
  }

  if (NewMapY != -1)
  {
    Map_CurY = NewMapY;
    Map_YShift = 0;
  }
  if (NewMapXShift != -1)
  {
    Map_XShift = NewMapXShift;
  }

  if (NewMapYShift != -1)
  {
    Map_YShift = NewMapYShift;
  }

  SVGA_curX = SVGA_curY = 0;
  SVGA_curXNext = SVGA_curYNext = 0;
  SVGA_curXPrev = SVGA_curYPrev = 0;
  VSB_curX = VSB_curY = 0;
  VSB_curXNext = VSB_curYNext = 0;

  SVGA_dx = SVGA_dy = 0;

  SVGA_wait (1);
//  SVGA_scroll ();

  sprCountLine = _div (SVGA_maxX+Map_XShift, Spr_SizeX);
  sprCountCol = _div (SVGA_maxY+Map_YShift, Spr_SizeY);

  mappos = Map_CurX+Map_CurY*Map_LenX;
  ypos = -Map_YShift;

  memset (VSB_sbuf, 0, VSB_virtualX * SVGA_maxY);

  for (y = 0; y < sprCountCol; y++)
  {
    xpos = -Map_XShift;

    for (x = mappos; x < mappos+sprCountLine; x++)
    {
      LIN_movWin (VSB_buf, xpos, ypos, VSB_virtualX, VSB_virtualY,
                  GetLevSpr (x), Spr_SizeX, Spr_SizeX, Spr_SizeY);

      mask = GetMaskSpr (x);
      if (mask)
      {
        LIN_movWin (VSB_sbuf, xpos, ypos, VSB_virtualX, VSB_virtualY,
                    mask, Spr_SizeX, Spr_SizeX, Spr_SizeY);
      }
      xpos+=Spr_SizeX;
    }
    ypos += Spr_SizeY;
    mappos+=Map_LenX;
  }

  DITH_shadeRaw (VSB_sbuf, VSB_virtualX,  VSB_buf, VSB_virtualX, VSB_virtualX, SVGA_maxY);
  SVGA_putWinNoVSB (VSB_buf, 0, 0, VSB_virtualX, SVGA_maxY, VSB_virtualX);

  SVGAC_flush ();
}



void SCROLL_updateFlush (void)
{
//  int curX = SVGA_curX;
//  int curY = SVGA_curY;

  #ifndef CGDK_TRIAL
  if (SVGA_getWin_ == B256_getWin)
  {
    if (UpdateCol == UpdateCol1)
      UpdateCol = UpdateCol2;
    else
      UpdateCol = UpdateCol1;

    if (UpdateLine == UpdateLine1)
      UpdateLine = UpdateLine2;
    else
      UpdateLine = UpdateLine1;
  }
  else
  #endif
  {
    if (leftright_sizeX)
    {
      SVGA_curX = leftright_curX;
      SVGA_curY = leftright_curY;

      SVGA_putWin_ (UpdateCol, leftright_x, 0, leftright_sizeX, SVGA_maxY, leftright_sizeX);

      leftright_sizeX = 0;
    }

    if (updown_sizeY)
    {
      SVGA_curX = updown_curX;
      SVGA_curY = updown_curY;

      SVGA_putWin_ (UpdateLine, 0, updown_y, SVGA_maxX, updown_sizeY, SVGA_maxX);

      updown_sizeY = 0;
    }
  }
//  SVGA_curX = curX;
//  SVGA_curY = curY;
}

/*
static int SCROLL_updateUpOK (int len)
{
  int i,j;
  int mappos, linepos;
  char *sprPos,*maskPos;
  int xoff,yoff;
  int vx,vy;
  unsigned vi;
  char c;
  unsigned register vsize = SVGA_virtual;

  vx = SVGA_curX;
  vy = SVGA_curY-1;
  SVGA_virtual2Real (&vx, &vy);
  vi = (unsigned)(vx + vy*SVGA_virtualX);

  linepos = (len)*SVGA_maxX;
  for (j = 0; j < len; j++)
  {
    if (Map_YShift == 0)
    {
      if (Map_CurY == 0)
        break;
      Map_YShift = Spr_SizeY;
      Map_CurY--;
    }
    Map_YShift--;

    mappos = Map_CurX + Map_CurY*Map_LenX;

    xoff = Map_XShift;
    yoff = Map_YShift*Spr_SizeX;
    sprPos = yoff+(char *)GetLevSpr (mappos);
    maskPos = yoff+(char *)GetMaskSpr (mappos);

    for (i = linepos-SVGA_maxX; i < linepos; i++)
    {
      if (vi >= vsize)
      {
        vi-=vsize;
      }
      VSB_sbuf [vi] = maskPos [xoff];
      c = DITH_get (sprPos [xoff], maskPos [xoff]);
      VSB_buf [vi] = c;
      UpdateLine [i] = c;

      if (xoff < Spr_SizeX-1)
      {
        xoff++;
      }
      else
      {
        xoff = 0;
        mappos++;
        sprPos = yoff+(char *)GetLevSpr (mappos);
        maskPos = yoff+(char *)GetMaskSpr (mappos);
      }
      vi++;
    }
    vi -= SVGA_virtualX+SVGA_maxX;
    if (vi >= vsize)
    {
      vi+=vsize;
    }
    linepos -= SVGA_maxX;
  }

  updown_buf = UpdateLine+linepos;
  updown_y = -j;
  updown_sizeY = j;
  updown_curX = SVGA_curX;
  updown_curY = SVGA_curY;


  SVGA_updateCurPos (0, -j);

  return j;
}
*/

static int SCROLL_updateDown (int len);
static int SCROLL_updateUp (int len);
static int SCROLL_updateLeft (int len);
static int SCROLL_updateRight (int len);

/*
static int SCROLL_updateDownOK (int len)
{
  int i,j;
  int mappos, linepos;
  int yshift;
  char *sprPos,*maskPos;
  int xoff, yoff;
  int vx,vy;
  unsigned vi;
  char c;
  unsigned register vsize = SVGA_virtual;

  vx = SVGA_curX;
  vy = SVGA_curY+SVGA_maxY;
  SVGA_virtual2Real (&vx, &vy);
  vi = (unsigned)(vy*SVGA_virtualX+vx);

  linepos = 0;
  for (j = 0; j < len; j++)
  {
    if ( (Map_LenY-Map_CurY)*Spr_SizeY-Map_YShift <= SVGA_maxY)
      break;

    if (Map_YShift+1 == Spr_SizeY)
    {
      Map_YShift = 0;
      Map_CurY++;
    }
    else
      Map_YShift++;

    mappos = Map_CurX + (Map_CurY+ Spr_CountPerCol)*Map_LenX;

    if (((Map_YShift + Spr_ColAdjust) < Spr_SizeY))
    {
      mappos -= Map_LenX;
      yshift = (Map_YShift + Spr_ColAdjust);
    }
    else
    yshift = (Map_YShift + Spr_ColAdjust) - Spr_SizeY;

    xoff = Map_XShift;
    yoff = yshift*Spr_SizeX;
    sprPos = yoff+(char *)GetLevSpr (mappos);
    maskPos = yoff+(char *)GetMaskSpr (mappos);

    i=linepos;
    linepos+=SVGA_maxX;
    for ( ; i < linepos; i++)
    {
      if (vi >= vsize)
      {
        vi-=vsize;
      }
      VSB_sbuf [vi] = maskPos [xoff];
      c = DITH_get (sprPos [xoff], maskPos [xoff]);
      VSB_buf [vi] = c;
      UpdateLine [i] = c;

      if (xoff < Spr_SizeX-1)
      {
        xoff++;
      }
      else
      {
        xoff = 0;
        mappos++;
        sprPos = yoff+(char *)GetLevSpr (mappos);
        maskPos = yoff+(char *)GetMaskSpr (mappos);
      }
      vi++;
    }
    vi+=SVGA_virtualX-SVGA_maxX;
  }

  updown_buf = UpdateLine;
  updown_y = SVGA_maxY;
  updown_sizeY = j;
  updown_curX = SVGA_curX;
  updown_curY = SVGA_curY;

  SVGA_updateCurPos (0, j);

  return j;
}
*/

/*
static int SCROLL_updateLeft (int len)
{
  int i,j;
  int mappos, colpos, _colpos;
  char *sprPos,*maskPos;
  int xoff;
  int yoff;
  int vx,vy;
  unsigned vi,vi_;
  char c;
  unsigned register vsize = SVGA_virtual;

  vx = SVGA_curX-1;
  vy = SVGA_curY;
  SVGA_virtual2Real (&vx, &vy);
  vi = (unsigned)(vx + vy*SVGA_virtualX);

  for (j = 0; j < len; j++)
  {
    colpos = len-j;
    if (Map_XShift == 0)
    {
      if (Map_CurX == 0)
        break;
      Map_XShift = Spr_SizeX;
      Map_CurX--;
    }
    Map_XShift--;

    colpos--;
    mappos = Map_CurX + Map_CurY*Map_LenX;

    xoff = Map_XShift;
    yoff = Map_YShift*Spr_SizeX;
    sprPos = xoff+(char *)GetLevSpr (mappos);
    maskPos = xoff+(char *)GetMaskSpr (mappos);
    _colpos = colpos;

    vi_ = vi;
    for (i = 0; i < SVGA_maxY; i++)
    {
      if (vi >= vsize)
      {
        vi-=vsize;
      }
      VSB_sbuf [vi] = maskPos [yoff];
      c = DITH_get (sprPos [yoff], maskPos [yoff]);
      UpdateCol [_colpos] = c;
      VSB_buf [vi] = c;

      if (yoff < (Spr_SizeY-1)*(Spr_SizeX))
      {
        yoff+=Spr_SizeX;
      }
      else
      {
        yoff = 0;
        mappos+=Map_LenX;
        sprPos = xoff+(char *)GetLevSpr (mappos);
        maskPos = xoff+(char *)GetMaskSpr (mappos);
      }
      _colpos += len;
      vi+=SVGA_virtualX;
    }
    vi=vi_-1;
  }

  leftright_buf = UpdateCol+colpos;
  leftright_x = -j;
  leftright_sizeX = j;
  leftright_formatX = len;
  leftright_curX = SVGA_curX;
  leftright_curY = SVGA_curY;

  SVGA_updateCurPos (-j, 0);

  return j;
}



*/

/*
static int SCROLL_updateRight (int len)
{
  int i,j;
  int mappos, colpos;
  int xshift ;
  char *sprPos,*maskPos;
  int xoff;
  int yoff;
  int vx,vy;
  unsigned vi,vi_;
  char c;
  unsigned register vsize = SVGA_virtual;

  vx = SVGA_curX+SVGA_maxX;
  vy = SVGA_curY;
  SVGA_virtual2Real (&vx, &vy);
  vi = (unsigned)(vy*SVGA_virtualX+vx);

  colpos = 0;
  for (j = 0; j < len; j++)
  {
    colpos=j;
    if ( (Map_LenX-Map_CurX)*Spr_SizeX-Map_XShift <= SVGA_maxX+1)
      break;

    if (Map_XShift == Spr_SizeX-1)
    {
      Map_XShift = 0;
      Map_CurX++;
    }
    else
      Map_XShift++;

    mappos = Map_CurX + Spr_CountPerLine-1 + Map_CurY*Map_LenX;
    mappos += (Map_XShift + Spr_LineAdjust) / Spr_SizeX;
    xshift = (Map_XShift + Spr_LineAdjust) % Spr_SizeX;

    xoff = xshift;
    yoff = Map_YShift*Spr_SizeX;
    sprPos = xoff+(char *)GetLevSpr (mappos);
    maskPos = xoff+(char *)GetMaskSpr (mappos);

    vi_ = vi;
    for (i = 0; i < SVGA_maxY; i++)
    {
      if (vi >= vsize)
      {
        vi -= vsize;
      }
      VSB_sbuf [vi] = maskPos [yoff];
      c = DITH_get (sprPos [yoff], maskPos [yoff]);
      UpdateCol [colpos] = c;
      VSB_buf [vi] = c;

      if (yoff < (Spr_SizeY-1)*(Spr_SizeX))
      {
        yoff+=Spr_SizeX;
      }
      else
      {
        yoff = 0;
        mappos+=Map_LenX;
        sprPos = xoff+(char *)GetLevSpr (mappos);
        maskPos = xoff+(char *)GetMaskSpr (mappos);
      }
      colpos += len;
      vi+=SVGA_virtualX;
    }
    vi=vi_+1;
  }

  leftright_buf = UpdateCol;
  leftright_x = SVGA_maxX;
  leftright_sizeX = j;
  leftright_formatX = len;
  leftright_curX = SVGA_curX;
  leftright_curY = SVGA_curY;

  SVGA_updateCurPos (j, 0);

  return j;
}
*/

extern "C" void SVGA_voidNull (void);

static int SCROLL_updatePos (int x, int y)
{
  int horiz, vert;
  int curX, curY, vcurX, vcurY;

  if (SVGA_scroll != SVGA_voidNull)
  {
    curX = SVGA_curX;
    curY = SVGA_curY;
    vcurX = VSB_curX;
    vcurY = VSB_curY;

    SCROLL_updateFlush ();

    SVGA_curX = curX;
    SVGA_curY = curY;

    if (x < 0)
    {
      x = -x;
      if (x > SVGA_maxXPlus)
        x = SVGA_maxXPlus;

      if ((limLeft >= 0) && ((x - curLeftRight) > limLeft))
        x = limLeft + curLeftRight;
      horiz = SCROLL_updateLeft (x);
      curLeftRight -= horiz;
    }
    else
    {
      if (x > SVGA_maxXPlus)
        x = SVGA_maxXPlus;

      if ((limRight >= 0) && ((curLeftRight + x) > limRight))
        x = limRight - curLeftRight;
      horiz = SCROLL_updateRight (x);
      curLeftRight += horiz;
    }

    if (y < 0)
    {
      y = -y;
      if (y > SVGA_maxYPlus)
        y = SVGA_maxYPlus;

      if ((limUp >= 0) && ((y - curUpDown) > limUp))
        y = limUp + curUpDown;
      vert = SCROLL_updateUp (y);
      curUpDown -= vert;
    }
    else
    {
      if (y > SVGA_maxYPlus)
        y = SVGA_maxYPlus;

      if ((limDown >= 0) && ((curUpDown + y) > limDown))
        y = limDown - curUpDown;
      vert = SCROLL_updateDown (y);
      curUpDown += vert;
    }

    SVGA_curXNext = SVGA_curX;
    SVGA_curYNext = SVGA_curY;
    SVGA_curX = curX;
    SVGA_curY = curY;
    VSB_curXNext = VSB_curX;
    VSB_curYNext = VSB_curY;
    VSB_curX = vcurX;
    VSB_curY = vcurY;

    return horiz+256*vert;
  }
  else
  {
    return 0;
  }
}


int SCROLL_update (int x, int y)
{
  int update;
  int bank;

  SVGA_syncCurPos ();

  update = SCROLL_updatePos (x, y);

  SVGA_dx = SVGA_curXNext-SVGA_curX;
  SVGA_dy = SVGA_curYNext-SVGA_curY;
  SVGA_virtual2RealDelta (&SVGA_dx, &SVGA_dy);

  MIRL_updateCurPosAll ();

  MIRC_flush ();

//  if (SVGA_VESA12_mode)
  {
    SVGAC_flush ();



/*    bank = hi (SVGA_curX + SVGA_curY * SVGA_virtualX);
    VESA_setBank (bank);

    SVGA_putSpr_ = VESA12_putSpr2_;
    SVGA_putWin_ = VESA12_putWin2_;

    VESA12_flushBank (bank);

    VESA_setBank (bank+1);
    VESA12_flushBank (bank+1);

    SVGA_putSpr_ = B256_putSpr2_;
    SVGA_putWin_ = B256_putWin2_; */

//    VESA12_flush ();
  }


//  if (SVGA_maxX >= 640)
//  {
//    SVGA_retraceStart ();
//    SVGA_timer++;
//  }
//  else
/*  {
    if (CGDK_debug)
    {
      while (KEYB_pressed (KEY_F11))
        ;
      if (KEYB_pressed (KEY_F12))
      {
        SVGA_wait (20);
      }
      else
      {
        SVGA_wait (1);
      }
    }
    else
    {
      SVGA_wait (1);
    }
  }
  */
/*  if (SVGA_VESA12_mode)
  {
    SVGA_putSpr_ = VESA12_putSpr2_;
    SVGA_putWin_ = VESA12_putWin2_;

//    VESA12_flushBank (bank);

    SVGA_putSpr_ = B256_putSpr2_;
    SVGA_putWin_ = B256_putWin2_;
  } */

//  if (SVGA_maxX >= 640)
//  {
//    SVGA_retraceEnd ();
//  }

//  if (update)
//  {
//    if (KEYB_pressed (KEY_BACKSPACE))
//    {
//      XVGA_scroll ();
//    }
//    else
//    {
//      SVGA_scroll ();
//    }
//  }

//  SVGAC_flush ();

  return update;
}

void SCROLL_flush (void)
{
  SCROLL_update (0,0);
}

void SCROLL_setLimit (int right, int down, int left, int up)
{
  limLeft = left;
  limRight = right;
  limUp = up;
  limDown = down;
}




static char SCROLL_walkKey;

#define SMOOTH_SLOW_SCROLL_X 1
#define SMOOTH_SLOW_SCROLL_Y 1
#define SMOOTH_NORMAL_SCROLL_X 4
#define SMOOTH_NORMAL_SCROLL_Y 4
#define SMOOTH_FAST_SCROLL_X 8
#define SMOOTH_FAST_SCROLL_Y 8

#define MOUSE_MAXSPEED_X 16 // greater vaule - greater speed
#define MOUSE_MAXSPEED_Y 15
#define MOUSE_SENSMIN 25
#define MOUSE_SENSDEFAULT 150 // less value - greater speed
#define MOUSE_SENSMAX 325
#define MOUSE_SENSSTEP 25
#define MOUSE_MAX_X 125 //less value - greater speed
#define MOUSE_MAX_Y ((3*MOUSE_MAX_X)/4)

static int SCROLL_walkMouseX (void)
{
  int x;

  x = ((MOUSE_MAXSPEED_X+1) * (-MOUSE_MAX_X/2 + MOUSE_info.x)) / (MOUSE_MAX_X/2);
  if (x < 0)
    x++;
  if (x > 0)
    x--;
  return x;
}

static int SCROLL_walkMouseY (void)
{
  int y;

  y = ((MOUSE_MAXSPEED_Y+1) * (-MOUSE_MAX_Y/2 + MOUSE_info.y)) / (MOUSE_MAX_Y/2);
  if (y < 0)
    y++;
  if (y > 0)
    y--;
  return y;
}

static void SCROLL_walkSmooth (void)
{
  int dx, dy;
  int i, j;

  dx = dy =0;

  if (KEYB_pressed (KEY_LEFT))
    dx--;
  if (KEYB_pressed (KEY_RIGHT))
    dx++;
  if (KEYB_pressed (KEY_UP))
    dy--;
  if (KEYB_pressed (KEY_DOWN))
    dy++;

  if (KEYB_ctrl)
  {
    dx = dx * SMOOTH_SLOW_SCROLL_X;
    dy = dy * SMOOTH_SLOW_SCROLL_Y;
    if (KEYB_alt)
    {
      dx = dx * SMOOTH_NORMAL_SCROLL_X;
      dy = dy * SMOOTH_NORMAL_SCROLL_Y;
    }
  }
  else
  {
    if (KEYB_alt)
    {
      dx = dx * SMOOTH_FAST_SCROLL_X;
      dy = dy * SMOOTH_FAST_SCROLL_Y;
    }
    else
    {
      dx = dx * SMOOTH_NORMAL_SCROLL_X;
      dy = dy * SMOOTH_NORMAL_SCROLL_Y;
    }
  }

  dx += SCROLL_walkMouseX ();
  dy += SCROLL_walkMouseY ();

  SCROLL_update (dx, dy);
}

#define PAGE_SLOW_SCROLL_X 4
#define PAGE_SLOW_SCROLL_Y 4
#define PAGE_FAST_SCROLL_X 16
#define PAGE_FAST_SCROLL_Y 15

static void SCROLL_walkPage (void)
{
  int dx, dy;
  int i, j;

  dx = dy = 0;

  if (KEYB_pressed (KEY_PGUP))
    dy--;
  if (KEYB_pressed (KEY_PGDN))
    dy++;
  if (KEYB_pressed (KEY_HOME))
    dx--;
  if (KEYB_pressed (KEY_END))
    dx++;

  if (KEYB_shifted)
  {
    dy = dy * PAGE_SLOW_SCROLL_Y;
    dx = dx * PAGE_SLOW_SCROLL_X;
  }
  else
  {
    dy = dy * PAGE_FAST_SCROLL_Y;
    dx = dx * PAGE_FAST_SCROLL_X;
  }

  if (dx | dy)
  {
    for (i = 0, j = 0;
         ((dx != 0) && (i+abs (dx) < SVGA_maxX)) || ((dy != 0) && (j+abs (dy) < SVGA_maxY));
         i+= abs (dx), j+= abs (dy))
    {
      if (SCROLL_update (dx, dy) == 0)
        break;
    }
    if (dx)
    {
      dx = sign (dx)*(SVGA_maxX-i);
    }
    if (dy)
    {
      dy = sign (dy)*(SVGA_maxY-j);
    }
    SCROLL_update (dx, dy);
  }
}


static int SCROLL_walkExit (void)
{
  int exitCode = -1;

  switch (SCROLL_walkKey)
  {
    case KEY_ESC:
      exitCode = 0;
      break;
    case KEY_ENTER:
      exitCode = 1;
      break;
    case KEY_BACKSPACE:
      exitCode = 2;
      break;
  }

  if (MOUSE_info.buttons.left)
  {
    while (MOUSE_info.buttons.left)
    {
      SCROLL_flush ();
    }
    exitCode = 1;
  }
  if (MOUSE_info.buttons.right)
  {
    while (MOUSE_info.buttons.right)
    {
      SCROLL_flush ();
    }
    exitCode = 2;
  }

  return exitCode;
}

static int mouseSens = MOUSE_SENSDEFAULT;

static void SCROLL_walkMouseSens (void)
{
  if (SCROLL_walkKey == KEY__MINUS)
  {
    if (mouseSens+MOUSE_SENSSTEP <= MOUSE_SENSMAX)
      mouseSens+=MOUSE_SENSSTEP;
   MOUSE_setSensitivity (mouseSens,mouseSens);
  }

  if (SCROLL_walkKey == KEY__PLUS)
  {
    if (mouseSens-MOUSE_SENSSTEP >= MOUSE_SENSMIN)
      mouseSens-=MOUSE_SENSSTEP;
   MOUSE_setSensitivity (mouseSens,mouseSens);
  }
}

int SCROLL_walk (void)
{
  int exitCode;

  MOUSE_setWindow (0, 0, MOUSE_MAX_X, MOUSE_MAX_Y);
  MOUSE_setPosition (MOUSE_MAX_X/2, MOUSE_MAX_Y/2);
  MOUSE_setSensitivity (MOUSE_SENSDEFAULT, MOUSE_SENSDEFAULT);

  do
  {
    SCROLL_walkKey = KEYB_get ();

    SCROLL_walkMouseSens ();

    SCROLL_walkSmooth ();

    SCROLL_walkPage ();

    exitCode = SCROLL_walkExit ();
  }
  while (exitCode == -1);

  SCROLL_flush ();

  SVGA_flush ();

  KEYB_update ();

  return exitCode;
}



static void SCROLL_updateUpDown (int mappos, int startY, int width)
{
  int w0, w1, w2;
  int l0, l1, l2;
  int loff, soff;
  int i,j;
  int newmappos;
  char *spr,*mask;
  int sizeX = Spr_SizeX;
  int sizeY = Spr_SizeY;

  if (startY > width)
  {
    w0 = width;
  }
  else
    w0 = startY;

  w2 = (width - w0) % sizeY;
  w1 = (width - w0) - w2;


  l0 = (sizeX - Map_XShift) % sizeX;
  l2 = (SVGA_maxX - l0) % sizeX;
  l1 = (SVGA_maxX - l0) - l2;

  spr = (char *) GetLevSpr (mappos);
  mask = (char *) GetMaskSpr (mappos);

  loff = 0;

  if (w0)
  {
    newmappos = mappos + Map_LenX;

    soff = (sizeY - startY) * sizeX;
    if (l0)
    {
      LIN_movWin_ (UpdateLine, SVGA_maxX,
                   spr + (sizeX - l0) + soff, sizeX, l0 , w0);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine, SVGA_maxX,
                     mask + (sizeX - l0) + soff, sizeX, l0 , w0);
      }
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
      loff += l0;
    }
    for (i = 0; i < l1; i+=sizeX)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr + soff, sizeX, sizeX, w0);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask + soff, sizeX, sizeX, w0);
      }
      loff += sizeX;
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    if (l2)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr + soff, sizeX, l2 , w0);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask + soff, sizeX, l2 , w0);
      }
      loff += l2;
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }

    mappos = newmappos;
    spr = (char *) GetLevSpr (mappos);
    mask = (char *) GetMaskSpr (mappos);

    loff += (w0 - 1) * SVGA_maxX;
  }

  for (j = 0; j < w1; j += sizeY)
  {
    newmappos = mappos + Map_LenX;

    if (l0)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr + (sizeX - l0), sizeX, l0 , sizeY);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask + (sizeX - l0), sizeX, l0 , sizeY);
      }
      loff += l0;
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    for (i = 0; i < l1; i+=sizeX)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr, sizeX, sizeX, sizeY);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask, sizeX, sizeX, sizeY);
      }
      loff += sizeX;
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    if (l2)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr, sizeX, l2 , sizeY);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask, sizeX, l2 , sizeY);
      }
      loff += l2;
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }

    mappos = newmappos;
    spr = (char *) GetLevSpr (mappos);
    mask = (char *) GetMaskSpr (mappos);
    loff += (sizeY  - 1) * SVGA_maxX;
  }

  if (w2)
  {
    if (l0)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr + (sizeX - l0), sizeX, l0 , w2);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask + (sizeX - l0), sizeX, l0 , w2);
      }
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
      loff += l0;
    }
    for (i = 0; i < l1; i+=sizeX)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr, sizeX, sizeX, w2);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask, sizeX, sizeX, w2);
      }
      loff += sizeX;
      mappos++;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    if (l2)
    {
      LIN_movWin_ (UpdateLine+loff, SVGA_maxX,
                   spr, sizeX, l2 , w2);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateLine+loff, SVGA_maxX,
                     mask, sizeX, l2 , w2);
      }
    }
  }

  DITH_shadeRaw (ShadeUpdateLine, SVGA_maxX, UpdateLine, SVGA_maxX, SVGA_maxX, width);
}


static int SCROLL_updateDown (int width)
{
  int maxw;
  int startY;
  int mappos;
  int shift;
  int sizeY = Spr_SizeY;

  maxw = (Map_LenY-Map_CurY)*sizeY-Map_YShift - SVGA_maxY;
  if (width > maxw)
    width = maxw;

  if (width)
  {
    mappos = Map_CurX + (Map_CurY + (Map_YShift + SVGA_maxY)/sizeY)*Map_LenX;
    startY = (SVGA_maxY + Map_YShift) % sizeY;
    if (startY)
      startY = sizeY - startY;

    SCROLL_updateUpDown (mappos, startY, width);

    VSB_putWin (UpdateLine, 0, SVGA_maxY, SVGA_maxX, width, SVGA_maxX);
    VSB_sput (ShadeUpdateLine, 0, SVGA_maxY, SVGA_maxX, width, SVGA_maxX);

    Map_YShift += width;
    Map_CurY += Map_YShift / sizeY;
    Map_YShift = Map_YShift % sizeY;
  }

  #ifndef CGDK_TRIAL
  if (SVGA_getWin_ == B256_getWin)
  {
    SVGA_putWin_ (UpdateLine, 0, SVGA_maxY, SVGA_maxX, width, SVGA_maxX);
  }
  else
  #endif
  {
//    updown_buf = UpdateLine;
    updown_y = SVGA_maxY;
    updown_sizeY = width;
    updown_curX = SVGA_curX;
    updown_curY = SVGA_curY;
  }

  SVGA_updateCurPos (0, width);

  return width;
}

static int SCROLL_updateUp (int width)
{
  int maxw;
  int mappos, startY;
  int sizeY = Spr_SizeY;

  maxw = Map_CurY*sizeY+Map_YShift;
  if (width > maxw)
    width = maxw;

  if (width)
  {
    Map_YShift -= width;

    if (Map_YShift < 0)
    {
      Map_CurY -= _div (-Map_YShift, sizeY);
      Map_YShift = Map_YShift % sizeY;
      if (Map_YShift)
      {
        Map_YShift += sizeY;
      }
    }

    mappos = Map_CurX + (Map_CurY + Map_YShift/sizeY)*Map_LenX;
    startY = -Map_YShift;
    if (startY)
      startY += sizeY;

    SCROLL_updateUpDown (mappos, startY, width);

    VSB_putWin (UpdateLine, 0, -width, SVGA_maxX, width, SVGA_maxX);
    VSB_sput (ShadeUpdateLine, 0, -width, SVGA_maxX, width, SVGA_maxX);
  }

  #ifndef CGDK_TRIAL
  if (SVGA_getWin_ == B256_getWin)
  {
    SVGA_putWin_ (UpdateLine, 0, -width, SVGA_maxX, width, SVGA_maxX);
  }
  else
  #endif
  {
//    updown_buf = UpdateLine;
    updown_y = -width;
    updown_sizeY = width;
    updown_curX = SVGA_curX;
    updown_curY = SVGA_curY;
  }

  SVGA_updateCurPos (0, -width);

  return width;
}

static void SCROLL_updateLeftRight (int mappos, int startX, int len)
{
  int w0, w1, w2;
  int l0, l1, l2;
  int loff, soff;
  int i, j;
  int newmappos;
  char *spr,*mask;
  int sizeX = Spr_SizeX;
  int sizeY = Spr_SizeY;

  if (startX > len)
  {
    l0 = len;
  }
  else
    l0 = startX;

  l2 = (len - l0) % sizeX;
  l1 = (len - l0) - l2;


  w0 = (sizeY - Map_YShift) % sizeY;
  w2 = (SVGA_maxY - w0) % sizeY;
  w1 = (SVGA_maxY - w0) - w2;

  spr = (char *) GetLevSpr (mappos);
  mask = (char *) GetMaskSpr (mappos);
  newmappos = mappos+1;
  soff = (sizeY - w0) * sizeX;

  if (l0)
  {
    loff = 0;

    if (w0)
    {
      LIN_movWin_ (UpdateCol, len,
                   spr + (sizeX - startX) + soff, sizeX, l0 , w0);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol, len,
                     mask + (sizeX - startX) + soff, sizeX, l0 , w0);
      }
      mappos+=Map_LenX;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
      loff += w0 * len;
    }
    for (i = 0; i < w1; i+=sizeY)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr + (sizeX - startX), sizeX, l0, sizeY);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask + (sizeX - startX), sizeX, l0, sizeY);
      }
      loff += sizeY * len;
      mappos+=Map_LenX;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    if (w2)
    {
      LIN_movWin_ (UpdateCol+loff, len, spr + (sizeX - startX), sizeX, l0 , w2);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len, mask + (sizeX - startX), sizeX, l0 , w2);
      }
    }
    mappos = newmappos;
    spr = (char *) GetLevSpr (mappos);
    mask = (char *) GetMaskSpr (mappos);
    newmappos++;
  }

  for (j = 0; j < l1; j += sizeX)
  {
    loff = l0 + j;

    if (w0)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr + soff, sizeX, sizeX , w0);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask + soff, sizeX, sizeX, w0);
      }
      loff += w0 * len;
      mappos+=Map_LenX;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    for (i = 0; i < w1; i+=sizeY)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr, sizeX, sizeX, sizeY);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask, sizeX, sizeX, sizeY);
      }
      loff += sizeY*len;
      mappos+=Map_LenX;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    if (w2)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr, sizeX, sizeX , w2);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask, sizeX, sizeX , w2);
      }
    }
    mappos = newmappos;
    spr = (char *) GetLevSpr (mappos);
    mask = (char *) GetMaskSpr (mappos);
    newmappos++;
  }

  if (l2)
  {
    loff = l0 + l1;

    if (w0)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr + soff, sizeX, l2 , w0);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask + soff, sizeX, l2 , w0);
      }
      mappos+=Map_LenX;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
      loff += w0*len;
    }
    for (i = 0; i < w1; i+=sizeY)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr, sizeX, l2, sizeY);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask, sizeX, l2, sizeY);
      }
      loff += sizeY*len;
      mappos+=Map_LenX;
      spr = (char *) GetLevSpr (mappos);
      mask = (char *) GetMaskSpr (mappos);
    }
    if (w2)
    {
      LIN_movWin_ (UpdateCol+loff, len,
                   spr, sizeX, l2 , w2);
      if (mask)
      {
        LIN_movWin_ (ShadeUpdateCol+loff, len,
                     mask, sizeX, l2 , w2);
      }
    }
  }

  DITH_shadeRaw (ShadeUpdateCol, len, UpdateCol, len, len, SVGA_maxY);
}

static int SCROLL_updateRight (int len)
{
  int maxl;
  int startX;
  int mappos;
  int sizeX = Spr_SizeX;

  maxl = (Map_LenX-Map_CurX)*sizeX-Map_XShift - SVGA_maxX;
  if (len > maxl)
    len = maxl;

//  if (len < 0)
// {
//    abs (0);
//  }

  if (len)
  {
    mappos = Map_CurX + (Map_XShift + SVGA_maxX)/sizeX + Map_CurY*Map_LenX;
    startX = (SVGA_maxX + Map_XShift) % sizeX;
    if (startX)
      startX = sizeX - startX;

    SCROLL_updateLeftRight (mappos, startX, len);

    VSB_putWin (UpdateCol, SVGA_maxX, 0, len, SVGA_maxY, len);
    VSB_sput (ShadeUpdateCol, SVGA_maxX, 0, len, SVGA_maxY, len);

    Map_XShift += len;
    Map_CurX += Map_XShift / sizeX;
    Map_XShift = Map_XShift % sizeX;
  }

  #ifndef CGDK_TRIAL
  if (SVGA_getWin_ == B256_getWin)
  {
    SVGA_putWin_ (UpdateCol, SVGA_maxX, 0, len, SVGA_maxY, len);
  }
  else
  #endif
  {
//    leftright_buf = UpdateCol;
    leftright_x = SVGA_maxX;
    leftright_sizeX = len;
  // // leftright_formatX = len;
    leftright_curX = SVGA_curX;
    leftright_curY = SVGA_curY;
  }

  SVGA_updateCurPos (len, 0);

  return len;
}

static int SCROLL_updateLeft (int len)
{
  int maxl;
  int mappos, startX;
  int sizeX = Spr_SizeX;

  maxl = Map_CurX*sizeX+Map_XShift;
  if (len > maxl)
    len = maxl;

//  if (len < 0)
//  {
//    abs (0);
//  }

  if (len)
  {
    Map_XShift -= len;

    if (Map_XShift < 0)
    {
      Map_CurX -= _div (-Map_XShift, sizeX);
      Map_XShift = Map_XShift % sizeX;
      if (Map_XShift)
      {
        Map_XShift += sizeX;
      }
    }

    mappos = Map_CurX + Map_XShift/sizeX + Map_CurY*Map_LenX;
    startX = -Map_XShift;
    if (startX)
      startX += sizeX;

    SCROLL_updateLeftRight (mappos, startX, len);

    VSB_putWin (UpdateCol, -len, 0, len, SVGA_maxY, len);
    VSB_sput (ShadeUpdateCol, -len, 0, len, SVGA_maxY, len);
  }

  #ifndef CGDK_TRIAL
  if (SVGA_getWin_ == B256_getWin)
  {
    SVGA_putWin_ (UpdateCol, -len, 0, len, SVGA_maxY, len);
  }
  else
  #endif
  {
//    leftright_buf = UpdateCol;
    leftright_x = -len;
    leftright_sizeX = len;
  //  leftright_formatX = len;
    leftright_curX = SVGA_curX;
    leftright_curY = SVGA_curY;
  }

  SVGA_updateCurPos (-len, 0);

  return len;
}
